define(["utils/graph","utils/add-logging"],function(a,b){"use strict";var c=a.Graph,d=function(a){a=a||{};var b=this;b.filters=[],b._jobsData=[],b._historyContentsMap={},b._toolMap={},b._outputIdToJobMap={},b.noInputJobs=[],b.noOutputJobs=[],b.filteredSetMetadata=[],b.filteredErroredJobs=[],b.dataKeys=["jobs","historyContents","tools"],c.call(b,!0,_.pick(a,b.dataKeys),_.omit(a,b.dataKeys))};return d.prototype=new a.Graph,d.prototype.constructor=d,b(d),d.prototype.init=function(a){a=a||{};var b=this;return b.options=_.defaults(a,{excludeSetMetadata:!1}),b.filters=b._initFilters(),c.prototype.init.call(b,a),b},d.prototype._initFilters=function(){var a=this,b=[];return a.options.excludeSetMetadata&&(a.filteredSetMetadata=[],b.push(function(b){return"__SET_METADATA__"!==b.job.tool_id?!0:(a.filteredSetMetadata.push(b.job.id),!1)})),a.options.excludeErroredJobs&&(a.filteredErroredJobs=[],b.push(function(b){return"error"!==b.job.state?!0:(a.filteredErroredJobs.push(b.job.id),!1)})),_.isArray(a.options.filters)&&(b=b.concat(a.options.filters)),a.debug("filters len:",b.length),b},d.prototype.read=function(a){var b=this;return _.has(a,"historyContents")&&_.has(a,"jobs")&&_.has(a,"tools")?(b.preprocessHistoryContents(a.historyContents||[]).preprocessTools(a.tools||{}).preprocessJobs(a.jobs||[]),b.createGraph(b._filterJobs()),b):c.prototype.read.call(this,a)},d.prototype.preprocessHistoryContents=function(a){this.info("processing history");var b=this;return b._historyContentsMap={},a.forEach(function(a){b._historyContentsMap[a.id]=_.clone(a)}),b},d.prototype.preprocessTools=function(a){this.info("processing tools");var b=this;return b._toolMap={},_.each(a,function(a,c){b._toolMap[c]=_.clone(a)}),b},d.prototype.preprocessJobs=function(a){this.info("processing jobs");var b=this;return b._outputIdToJobMap={},b._jobsData=b.sort(a).map(function(a){return b.preprocessJob(_.clone(a))}),b},d.prototype.sort=function(a){function b(a,b){return a.create_time>b.create_time?1:a.create_time<b.create_time?-1:0}return a.sort(b)},d.prototype.preprocessJob=function(a){var b=this,c={job:a};return c.inputs=b._processInputs(a),0===_.size(c.inputs)&&b.noInputJobs.push(a.id),c.outputs=b._processOutputs(a),0===_.size(c.outputs)&&b.noOutputJobs.push(a.id),c.tool=b._toolMap[a.tool_id],c},d.prototype._processInputs=function(a){var b=this,c=a.inputs,d={};return _.each(c,function(a,c){a=_.clone(b._validateInputOutput(a)),a.name=c,a.content=b._historyContentsMap[a.id],d[a.id]=a}),d},d.prototype._validateInputOutput=function(a){if(!a.id)throw new Error("No id on job input/output: ",JSON.stringify(a));if(!a.src||"hda"!==a.src)throw new Error("Bad src on job input/output: ",JSON.stringify(a));return a},d.prototype._processOutputs=function(a){var b=this,c=a.outputs,d={};return _.each(c,function(c,e){c=_.clone(b._validateInputOutput(c)),c.name=e,c.content=b._historyContentsMap[c.id],d[c.id]=c,b._outputIdToJobMap[c.id]=a.id}),d},d.prototype._filterJobs=function(){var a=this;return a._jobsData.filter(function(b,c){return a._filterJob(b,c)})},d.prototype._filterJob=function(a){for(var b=this,c=0;c<b.filters.length;c++)if(!b.filters[c].call(b,a))return b.debug("	 job",a.job.id," has been filtered out by function:\n",b.filters[c]),!1;return!0},d.prototype.createGraph=function(a){var b=this;return b.debug("connections:"),_.each(a,function(a){var c=a.job.id;b.debug("	",c,a),b.createVertex(c,a)}),_.each(a,function(a){var c=a.job.id;_.each(a.inputs,function(a,d){var e=b._outputIdToJobMap[d];if(!e){var f=b.createJobLessVertex(d);e=f.name}b.createEdge(e,c,b.directed,{dataset:d})})}),b.debug("final graph: ",JSON.stringify(b.toVerticesAndEdges(),null,"  ")),b},d.prototype.createJobLessVertex=function(a){var b="copy-",c=b+a;return this.createVertex(c,this._historyContentsMap[a])},d.prototype.weakComponentGraphArray=function(){var a=this;return this.weakComponents().map(function(b){return b.vertices.sort(function(a,b){var c=a.data.job?a.data.job.create_time:a.data.create_time,d=b.data.job?b.data.job.create_time:b.data.create_time;return c>d?1:d>c?-1:0}),new Graph(a.directed,b)})},d.prototype._jobsDataMap=function(){var a={};return this._jobsData.forEach(function(b){a[b.job.id]=b}),a},d});
//# sourceMappingURL=../../../maps/mvc/history/job-dag.js.map